# coding: utf-8

"""
    Hatchet API

    The Hatchet API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing_extensions import Annotated, Self

from hatchet_sdk.clients.cloud_rest.models.managed_worker_create_request_build_config_steps_inner import (
    ManagedWorkerCreateRequestBuildConfigStepsInner,
)


class ManagedWorkerCreateRequestBuildConfig(BaseModel):
    """
    ManagedWorkerCreateRequestBuildConfig
    """  # noqa: E501

    github_installation_id: Annotated[
        str, Field(min_length=36, strict=True, max_length=36)
    ] = Field(alias="githubInstallationId")
    github_repository_owner: StrictStr = Field(alias="githubRepositoryOwner")
    github_repository_name: StrictStr = Field(alias="githubRepositoryName")
    github_repository_branch: StrictStr = Field(alias="githubRepositoryBranch")
    steps: List[ManagedWorkerCreateRequestBuildConfigStepsInner]
    __properties: ClassVar[List[str]] = [
        "githubInstallationId",
        "githubRepositoryOwner",
        "githubRepositoryName",
        "githubRepositoryBranch",
        "steps",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ManagedWorkerCreateRequestBuildConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in steps (list)
        _items = []
        if self.steps:
            for _item in self.steps:
                if _item:
                    _items.append(_item.to_dict())
            _dict["steps"] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ManagedWorkerCreateRequestBuildConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "githubInstallationId": obj.get("githubInstallationId"),
                "githubRepositoryOwner": obj.get("githubRepositoryOwner"),
                "githubRepositoryName": obj.get("githubRepositoryName"),
                "githubRepositoryBranch": obj.get("githubRepositoryBranch"),
                "steps": (
                    [
                        ManagedWorkerCreateRequestBuildConfigStepsInner.from_dict(_item)
                        for _item in obj["steps"]
                    ]
                    if obj.get("steps") is not None
                    else None
                ),
            }
        )
        return _obj
